#include <sstream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <string>
#include <cassert>
#include <ctime>
#include <map>
#include <math.h>
#include <cstdio>
#include <set>
#include <deque>
#include <memory.h>
#include <queue>

#pragma comment(linker, "/STACK:64000000")
typedef long long ll;

using namespace std;

const int MAXN = 1 << 20;
const int MOD = 1; // 1000 * 1000 * 1000 + 7;

ll slowsolve(string s) {
	int n = s.length();
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 1; j < (n + 1) / 2; j++) {
			if (s[i] == s[(i + j + n) % n] && s[i] == s[(i - j + n) % n]) {
				ans++;
			}
		}
	}
	if (n % 3 == 0) {
		for (int i = 0; i < n / 3; i++) {
			if (s[i] == s[i + n / 3] && s[i] == s[i + n / 3 * 2]) {
				ans -= 2;
			}
		}
	}
	return ans;
}

// sum i = 0..n-1
//   sum j = 1..(n-1)/2
//     a[i - j] * a[i] * a[i + j] + (1 - a[i - j]) * (1 - a[i]) * (1 - a[i + j])
//     -a[i - j] - a[i] - a[i + j] + a[i - j] * a[i] + a[i + j] * a[i] + a[i - j] * a[i + j] + 1

int n;
ll curAns;
int eq;
int sum, sum0, sum1;
int a[MAXN];

ll fastsolve(string s) {
	n = s.length();
	for (int i = 0; i < n; i++) a[i] = s[i] == 'W';

	sum = 0;
	for (int i = 0; i < n; i++) sum += a[i];

	ll ans = 1LL * n * ((n - 1) / 2);
	for (int i = 0; i < n; i++) {
		ans -= a[i] * ((n - 1) / 2 + (n - 1 - (n % 2 == 0)));
		ans += a[i] * (sum - a[i] - (n % 2 == 0 ? a[(i + n / 2) % n] : 0));
	}
	if (n % 2 == 1) {
		ans += 1LL * sum * (sum - 1) / 2;
	}
	else {
		sum0 = sum1 = 0;
		for (int i = 0; i < n; i++) {
			if (i % 2 == 0) sum0 += a[i];
			else sum1 += a[i];
		}
		ans += 1LL * sum0 * (sum0 - 1) + 1LL * sum1 * (sum1 - 1);
	}

	eq = 0;
	if (n % 3 == 0) {
		for (int i = 0; i < n / 3; i++) {
			if (s[i] == s[i + n / 3] && s[i] == s[i + n / 3 * 2]) {
				eq++;
			}
		}
	}

	curAns = ans;

	return ans;
}

void change(int i) {
	if (n % 3 == 0) {
		if (a[i] == a[(i + n / 3) % n] && a[i] == a[(i + n / 3 * 2) % n]) {
			eq--;
		}
	}

	curAns += (a[i] - (a[i] ^ 1)) * ((n - 1) / 2 + (n - 1 - (n % 2 == 0)));
	curAns += (-a[i] + (a[i] ^ 1)) * (sum - a[i] - (n % 2 == 0 ? a[(i + n / 2) % n] : 0)) * 2;

	if (n % 2 == 1) {
		curAns -= 1LL * sum * (sum - 1) / 2;
	}
	else {
		curAns -= 1LL * sum0 * (sum0 - 1) + 1LL * sum1 * (sum1 - 1);
	}

	sum += (-a[i]) + (a[i] ^ 1);
	if (i % 2 == 0) sum0 += (-a[i]) + (a[i] ^ 1);
	else sum1 += (-a[i]) + (a[i] ^ 1);

	if (n % 2 == 1) {
		curAns += 1LL * sum * (sum - 1) / 2;
	}
	else {
		curAns += 1LL * sum0 * (sum0 - 1) + 1LL * sum1 * (sum1 - 1);
	}

	a[i] ^= 1;

	if (n % 3 == 0) {
		if (a[i] == a[(i + n / 3) % n] && a[i] == a[(i + n / 3 * 2) % n]) {
			eq++;
		}
	}
}

ll fastsolve1(string s) {
	string t = s;
	for (int i = 0; i < (int)t.length(); i++) t[i] = (char)('B' + ('W' - 'B') * (rand() % 2));
	fastsolve(t);
	for (int i = 0; i < (int)t.length(); i++) if (t[i] != s[i]) change(i);
	return curAns - 2 * eq;
}

void stress() {
	for (int it = 0;; it++) {
		cerr << it << endl;
		int n = 3 + rand() % 10;
		string s;
		for (int i = 0; i < n; i++) s += (char)('B' + ('W' - 'B') * (rand() % 2));
		ll ans1 = fastsolve1(s);
		ll ans2 = slowsolve(s);
		if (ans1 != ans2) {
			cout << ans1 << " instead of " << ans2 << endl << s << endl;
			fastsolve(s);
			exit(0);
		}
	}
}

int main() {
	freopen("triangles.in", "r", stdin);
    freopen("triangles.out", "w", stdout);

    int n, m;
    string s;
    cin >> n >> m >> s;
    assert(n <= 200000 && m <= 1);
    fastsolve(s);
    for (int i = 0; i < m; i++) {
        int id;
        cin >> id;
        change(id - 1);
        cout << curAns - 2 * eq << endl;
    }

	return 0;
}